package com.zcloud.modules.kangzai.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zcloud.common.utils.PageUtils;
import com.zcloud.modules.kangzai.dao.BusUrbanFloodPointDao;
import com.zcloud.modules.kangzai.entity.BusUrbanFloodPointEntity;
import com.zcloud.modules.kangzai.service.BusUrbanFloodPointService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.List;
import java.util.Map;

/**
 * @Author fangjiakai
 * @Desc 城市防涝点详情表(BusUrbanFloodPoint)表服务实现类
 * @Date 2025-06-09 10:15:00
 */
@Service("busUrbanFloodPointService")
public class BusUrbanFloodPointServiceImpl extends ServiceImpl<BusUrbanFloodPointDao, BusUrbanFloodPointEntity> implements BusUrbanFloodPointService {

    @Override
    public BusUrbanFloodPointEntity queryByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusUrbanFloodPointEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectOne(queryWrapper);
    }

    @Override
    public List<BusUrbanFloodPointEntity> queryListByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusUrbanFloodPointEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectList(queryWrapper);
    }

    @Override
    public PageUtils listPage(Map<String, Object> params) {
        Page<Map<String, Object>> page = new Page<>(Integer.parseInt(params.get("curPage").toString()), Integer.parseInt(params.get("limit").toString()));
        params.put("isDelete", 0);
        IPage<BusUrbanFloodPointEntity> ipage = baseMapper.listPage(page, params);
        return new PageUtils(ipage);
    }


    @Override
    public void delete(String urbanFloodPointId, String userId) {
        UpdateWrapper<BusUrbanFloodPointEntity> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("urban_flood_point_id", urbanFloodPointId);

        BusUrbanFloodPointEntity busUrbanFloodPoint = new BusUrbanFloodPointEntity();
        busUrbanFloodPoint.setOperator(userId);
        busUrbanFloodPoint.setIsDelete(1);

        this.update(busUrbanFloodPoint, updateWrapper);
    }
}
